# Fuelcell
[![Code Climate](https://codeclimate.com/github/engine8/fuelcell/badges/gpa.svg)](https://codeclimate.com/github/engine8/fuelcell)
[![Test Coverage](https://codeclimate.com/github/engine8/fuelcell/badges/coverage.svg)](https://codeclimate.com/github/engine8/fuelcell/coverage)
[![Build Status](https://travis-ci.org/engine8/fuelcell.svg?branch=master)](https://travis-ci.org/engine8/fuelcell)

## Description
Fuelcell is tool for parsing command line arguments & options, allowing you to
concentrate more on your application and less on the logic needed to interface
with your users through the command line. It handles mapping arguments to
executable actions, defining options & arguments, self documenting help system,
through a dsl that is small and simple to learn.

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'fuelcell'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install fuelcell

## Usage
```ruby
require 'fuelcell'

Fuelcell.start(ARGV.dup) do
  desc 'this is a basic hello world app'
  arg 'name', default: 'World'
  run ->(opts, args, shell) {
    shell.puts "Hello #{args.name}"
  }
end
```

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake false` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/[USERNAME]/fuelcell. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [Contributor Covenant](contributor-covenant.org) code of conduct.

